C     Copyright (C) 2002-2007 The SSI Project. All rights reserved.
C
C     Redistribution and use in source and binary forms, with or without
C     modification, are permitted provided that the following conditions
C     are met:
C
C       * Redistributions of source code must retain the above copyright
C         notice, this list of conditions and the following disclaimer.
C       * Redistributions in binary form must reproduce the above copyright
C         notice, this list of conditions and the following disclaimer in the
C         documentation and/or other materials provided with the distribution.
C       * Neither the name of the project nor the names of its contributors
C         may be used to endorse or promote products derived from this
C         software without specific prior written permission.
C
C     THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
C     OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
C     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
C     DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
C     INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
C     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
C     SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
C     HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
C      STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
C     ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
C     THE POSSIBILITY OF SUCH DAMAGE.
C
C     $Id: fdemo1.f,v 1.4 2007/10/31 06:14:44 kajiyama Exp $

      PROGRAM FDEMO1

      INCLUDE 'client.h'

      PARAMETER (N=4)
      REAL *8 A(N,N), B(N), X(N)
      INTEGER *4 I, J, C, IERR

C     prepare dense matrix and vector
      C = 1
      DO I = 1,N
         DO J = 1,N
            A(I,J) = C
            C = C + 1
         END DO
         B(I) = I * 2 - 1
         X(I) = 0
      END DO

      CALL SILC_INIT(IERR)

C     solve a sysmte of linear equations
      CALL SILC_PUT_MATRIX('A', A, N, N, SILC_DOUBLE, IERR)
      CALL SILC_PUT_COLUMN_VECTOR('b', B, N, SILC_DOUBLE, IERR)
      CALL SILC_EXEC('x = A \ b', IERR)
      CALL PRINT_COLUMN_VECTOR('b', B, N)

C     call procedure `split'
      CALL SILC_EXEC('split(A, L, D, U)', IERR)
      CALL SILC_GET_MATRIX('L', A, IERR)
      CALL PRINT_MATRIX('L', A, N, N)
      CALL SILC_GET_MATRIX('D', A, IERR)
      CALL PRINT_MATRIX('D', A, N, N)
      CALL SILC_GET_MATRIX('U', A, IERR)
      CALL PRINT_MATRIX('U', A, N, N)

      CALL SILC_FINALIZE(IERR)

      END

      SUBROUTINE PRINT_MATRIX(NAME, V, M, N)
      CHARACTER NAME
      REAL *8 V(M,N)
      INTEGER M, N, I, J
      WRITE(*,100) NAME
      DO J = 1,N
         DO I = 1,M
            WRITE(*,110) I, J, V(I,J)
         END DO
      END DO
 100  FORMAT('MATRIX "', A, '"')
 110  FORMAT('  v.d[',I1,',',I1,'] = ', F9.6)
      END

      SUBROUTINE PRINT_COLUMN_VECTOR(NAME, V, N)
      CHARACTER NAME
      REAL *8 V(N)
      INTEGER N, I
      WRITE(*,200) NAME
      DO I = 1,M
         WRITE(*,210) I, V(I)
      END DO
 200  FORMAT('COLUMN VECTOR "', A, '"')
 210  FORMAT('  v.d[',I1,'] = ', F9.6)
      END
