C     Copyright (C) 2002-2007 The SSI Project. All rights reserved.
C
C     Redistribution and use in source and binary forms, with or without
C     modification, are permitted provided that the following conditions
C     are met:
C
C       * Redistributions of source code must retain the above copyright
C         notice, this list of conditions and the following disclaimer.
C       * Redistributions in binary form must reproduce the above copyright
C         notice, this list of conditions and the following disclaimer in the
C         documentation and/or other materials provided with the distribution.
C       * Neither the name of the project nor the names of its contributors
C         may be used to endorse or promote products derived from this
C         software without specific prior written permission.
C
C     THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
C     OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
C     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
C     DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
C     INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
C     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
C     SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
C     HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
C      STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
C     ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
C     THE POSSIBILITY OF SUCH DAMAGE.
C
C     $Id: fdemo3.f,v 1.4 2007/10/31 06:14:44 kajiyama Exp $

      PROGRAM FDEMO3

      INCLUDE 'client.h'

      PARAMETER (N=500,NNZ=N*3-2)
      REAL *8 VALUE(NNZ), B(N), X(N)
      REAL *8 NORM, D
      REAL *8 WTIME, T
      INTEGER *4 ROW(N+1), INDEX(NNZ)
      INTEGER *4 I, C, IERR
C
C     create a tridiagonal matrix in CRS format
      C = 1
      DO I = 1,N
         ROW(I) = C
         IF (I.EQ.1) THEN
            VALUE(C) =  2.0
            INDEX(C) =  I
            C = C + 1
            VALUE(C) = -1.0
            INDEX(C) =  I + 1
            C = C + 1
            B(I) = -1.0
            X(I) =  0.0
         ELSE IF (I.LT.N) THEN
            VALUE(C) = -1.0
            INDEX(C) =  I - 1
            C = C + 1
            VALUE(C) =  2.0
            INDEX(C) =  I
            C = C + 1
            VALUE(C) = -1.0
            INDEX(C) =  I + 1
            C = C + 1
            B(I) =  0.0
            X(I) =  0.0
         ELSE
            VALUE(C) = -1.0
            INDEX(C) =  I - 1
            C = C + 1
            VALUE(C) =  2.0
            INDEX(C) =  I
            C = C + 1
            B(I) = -1.0
            X(I) =  0.0
         END IF
      END DO
      ROW(N+1) = C

      T = WTIME()

C     initialize SILC
      CALL SILC_INIT(IERR)

C     put matrix A
      CALL SILC_PUT_MATRIX_CRS('A', VALUE, N, N, NNZ, ROW, INDEX,
     &     SILC_DOUBLE, IERR)

C     put vector b
      CALL SILC_PUT_COLUMN_VECTOR('b', B, N, SILC_DOUBLE, IERR)

C     solve linear equations
      CALL SILC_EXEC('x = A \ b', IERR)

C     get vector x
      CALL SILC_GET_COLUMN_VECTOR('x', X, IERR)

C     finalize SILC
      CALL SILC_FINALIZE(IERR)

      WRITE(*,100) WTIME() - T
 100  FORMAT(F7.5, 's')

C     check solution
      NORM = 0.0
      DO I = 1, N 
         D = B(I)
         DO J = ROW(I), ROW(I+1)-1
            D = D - VALUE(J) * X(INDEX(J))
         END DO
         NORM = NORM + D * D
      END DO
      WRITE(*,200) SQRT(NORM)
 200  FORMAT('||b-Ax|| = ', e13.7e2)

      END
