# Copyright (C) 2002-2007 The SSI Project. All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the project nor the names of its contributors 
#       may be used to endorse or promote products derived from this software 
#       without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
# OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
#  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $Id: demo3_band.py,v 1.4 2007/10/31 06:19:46 kajiyama Exp $

import sys

from silc import *

if len(sys.argv) > 1:
    N = int(sys.argv[1])
else:
    N = 1000
A = [[-1] * N, [2] * N, [-1] * N]
b = [-1] + [0] * (N - 2) + [-1]

obj = Envelope()

SILC_INIT()

obj.type = SILC_MATRIX_TYPE
obj.format = SILC_FORMAT_BAND
obj.precision = SILC_DOUBLE
obj.m = obj.n = N
obj.l = 1
obj.u = 1
obj.v = A
SILC_PUT("A", obj)

obj.type = SILC_COLUMN_VECTOR_TYPE
obj.precision = SILC_DOUBLE
obj.length = N
obj.v = b
SILC_PUT("b", obj)

SILC_EXEC("x = A \\ b")

# check solution
SILC_EXEC("r = b - A * x")
SILC_EXEC("norm = r' * r")
SILC_GET(obj, "norm")
print "||b-Ax|| = %e" % obj.v

SILC_FINALIZE()
