# Copyright (C) 2002-2007 The SSI Project. All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the project nor the names of its contributors 
#       may be used to endorse or promote products derived from this software 
#       without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
# OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
#  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.
#
# $Id: spyplot.py,v 1.4 2007/10/31 06:19:47 kajiyama Exp $

from silc import *

import Image
import ImageDraw
import sys

if len(sys.argv) != 3:
    print "Usage: %s name output.png" % sys.argv[0]
    sys.exit(1)

SILC_INIT()

object = Envelope()
SILC_GET(object, sys.argv[1])

SILC_FINALIZE()

assert object.type == SILC_MATRIX_TYPE and object.format == SILC_FORMAT_CRS

if object.m > 1024:
    def scale(x, base=float(object.m)):
        return int(1024 * x / base)
else:
    def scale(x):
        return x

im = Image.new("L", (scale(object.n), scale(object.m)), 255)

draw = ImageDraw.Draw(im)
for i in range(object.m):
    for j in range(object.row[i], object.row[i+1]):
        draw.point((scale(object.index[j]), scale(i)), fill=0)

im.save(sys.argv[2])
