/*
 * Copyright (C) 2002-2007 The SSI Project. All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the project nor the names of its contributors 
 *       may be used to endorse or promote products derived from this software 
 *       without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: lapack_scsl.c,v 1.4 2007/10/31 06:23:11 kajiyama Exp $
 */

#include <scsl_blas.h>

void
call_sgbtrf(int m, int n, int kl, int ku, float *a, int lda, int *ipiv,
	    int *info)
{
  sgbtrf(m, n, kl, ku, a, lda, ipiv, info);
}

void
call_dgbtrf(int m, int n, int kl, int ku, double *a, int lda, int *ipiv,
	    int *info)
{
  dgbtrf(m, n, kl, ku, a, lda, ipiv, info);
}

void
call_cgbtrf(int m, int n, int kl, int ku, float *a, int lda, int *ipiv,
	    int *info)
{
  cgbtrf(m, n, kl, ku, (scsl_complex *)a, lda, ipiv, info);
}

void
call_zgbtrf(int m, int n, int kl, int ku, double *a, int lda, int *ipiv,
	    int *info)
{
  zgbtrf(m, n, kl, ku, (scsl_zomplex *)a, lda, ipiv, info);
}

void
call_sgbtrs(char trans, int n, int kl, int ku, int nrhs, float *a,
	    int lda, int *ipiv, float *b, int ldb, int *info)
{
  sgbtrs(trans, n, kl, ku, nrhs, a, lda, ipiv, b, ldb, info);
}

void
call_dgbtrs(char trans, int n, int kl, int ku, int nrhs, double *a,
	    int lda, int *ipiv, double *b, int ldb, int *info)
{
  dgbtrs(trans, n, kl, ku, nrhs, a, lda, ipiv, b, ldb, info);
}

void
call_cgbtrs(char trans, int n, int kl, int ku, int nrhs, float *a,
	    int lda, int *ipiv, float *b, int ldb, int *info)
{
  cgbtrs(trans, n, kl, ku, nrhs, (scsl_complex *)a, lda, ipiv,
	 (scsl_complex *)b, ldb, info);
}

void
call_zgbtrs(char trans, int n, int kl, int ku, int nrhs, double *a,
	    int lda, int *ipiv, double *b, int ldb, int *info)
{
  zgbtrs(trans, n, kl, ku, nrhs, (scsl_zomplex *)a, lda, ipiv,
	 (scsl_zomplex *)b, ldb, info);
}
