/*
 * Copyright (C) 2002-2007 The SSI Project. All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the project nor the names of its contributors 
 *       may be used to endorse or promote products derived from this software 
 *       without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: const.h,v 1.4 2007/10/31 05:50:17 kajiyama Exp $
 */

#ifndef SILC_CONST_H
#define SILC_CONST_H 1

/* type */
#define SILC_SCALAR_TYPE         1
#define SILC_RANGE_TYPE          2
#define SILC_COLUMN_VECTOR_TYPE  4
#define SILC_ROW_VECTOR_TYPE     8
#define SILC_MATRIX_TYPE         16
#define SILC_CUBIC_ARRAY_TYPE    32

/* precision */
#define SILC_FLOAT           1
#define SILC_DOUBLE          2
#define SILC_COMPLEX         4
#define SILC_DOUBLE_COMPLEX  8
#define SILC_INT             16
#define SILC_LONG            32

/* iotype */
#define SILC_PARAM_IN     1
#define SILC_PARAM_OUT    2
#define SILC_PARAM_INOUT  3

/* limits */
#define SILC_MAXNAMELEN 63
#define SILC_SIGNATURE_MAX 1023

#ifndef SILC_DEFAULT_FORMAT
#define SILC_DEFAULT_FORMAT "dense"
#endif

#endif /* SILC_CONST_H */
