/*
 * Copyright (C) 2002-2007 The SSI Project. All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the project nor the names of its contributors 
 *       may be used to endorse or promote products derived from this software 
 *       without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: dl.h,v 1.4 2007/10/31 05:50:17 kajiyama Exp $
 */

#ifndef SILC_DL_H
#define SILC_DL_H 1

#include "const.h"

#ifdef STATIC_MODULES

typedef void * silc_handle;

#else /* STATIC_MODULES */

#ifdef _osx

#include <mach-o/dyld.h>

typedef NSModule silc_handle;

#else /* _osx */

#ifdef _WIN32

#include <windows.h>

typedef HINSTANCE silc_handle;

#else /* _WIN32 */

#include <dlfcn.h>
#ifdef HAVE_LINK_H
#include <link.h>
#endif

typedef void * silc_handle;

#endif /* _WIN32 */

#endif /* _osx */

#endif /* STATIC_MODULES */

silc_handle silc_dlopen(char *);
void *silc_dlsym(silc_handle, char *);
int silc_dlclose(silc_handle);
const char *silc_dlerror(void);

#endif /* SILC_DL_H */
