/*
 * Copyright (C) 2002-2007 The SSI Project. All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the project nor the names of its contributors 
 *       may be used to endorse or promote products derived from this software 
 *       without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: modifier.h,v 1.4 2007/10/31 05:50:18 kajiyama Exp $
 */

/* modifier.h */

#ifndef SILC_MODIFIER_H
#define SILC_MODIFIER_H 1

#include "object.h"
#include "clist.h"

typedef struct {
  int n;
  clist_t *subscript[3];
  int conjugate, transpose, negate;
} silc_modifier_t;

#if defined(_WIN32) && !defined(STATIC_MODULES)
#ifdef _EXPORTING
#define DECLSPEC __declspec(dllexport)
#else
#define DECLSPEC __declspec(dllimport)
#endif
#else
#define DECLSPEC
#endif

silc_modifier_t *modifier_new(void);
void modifier_free(silc_modifier_t *);
DECLSPEC silc_object_t *modifier_apply_all(silc_object_t *, silc_modifier_t *);
DECLSPEC silc_object_t *modifier_apply_subscript(silc_object_t *, int, clist_t *[]);
DECLSPEC silc_object_t *modifier_apply_conjugate_transpose(silc_object_t *);
DECLSPEC silc_object_t *modifier_apply_complex_conjugate(silc_object_t *);
DECLSPEC silc_object_t *modifier_apply_transpose(silc_object_t *);
DECLSPEC silc_object_t *modifier_apply_negate(silc_object_t *);

#endif /* SILC_MODIFIER_H */
