/*
 * Copyright (C) 2002-2007 The SSI Project. All rights reserved. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the project nor the names of its contributors 
 *       may be used to endorse or promote products derived from this software 
 *       without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE SSI PROJECT ``AS IS'' AND ANY EXPRESS 
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE SSI PROJECT BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 *  STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: net.h,v 1.4 2007/10/31 05:50:18 kajiyama Exp $
 */

#ifndef SILC_NET_H
#define SILC_NET_H 1

#if defined(_WIN32) && !defined(STATIC_MODULES)
#ifdef _EXPORTING
#define DECLSPEC __declspec(dllexport)
#else
#define DECLSPEC __declspec(dllimport)
#endif
#else
#define DECLSPEC
#endif

#define SILC_BIG_ENDIAN    1234
#define SILC_LITTLE_ENDIAN 3412
void set_endian(int);
void set_size(int);

DECLSPEC ssize_t send_all(int, void *, size_t, int);
DECLSPEC ssize_t recv_all(int, void *, size_t, int);
DECLSPEC void send_ack(int);
DECLSPEC void recv_ack(int);
DECLSPEC int recv_32_array(int, void *, size_t, int);
DECLSPEC int recv_64_array(int, void *, size_t, int);
DECLSPEC int recv_size(int, size_t *, int);
DECLSPEC int send_32_array(int, void *, size_t, int);
DECLSPEC int send_64_array(int, void *, size_t, int);
DECLSPEC int send_size(int, size_t *, int);

#if 0 /* experimental */
int bulk_recv_32_array(int, void *, size_t, int);
#endif

#endif /* SILC_NET_H */
